Home | History | Annotate | Download | only in tests-mx32
      1 #!/bin/sh
      2 #
      3 # Ensure that strace can detach from sleeping processes.
      4 #
      5 # Copyright (c) 2013-2015 Dmitry V. Levin <ldv (at] altlinux.org>
      6 # All rights reserved.
      7 #
      8 # Redistribution and use in source and binary forms, with or without
      9 # modification, are permitted provided that the following conditions
     10 # are met:
     11 # 1. Redistributions of source code must retain the above copyright
     12 #    notice, this list of conditions and the following disclaimer.
     13 # 2. Redistributions in binary form must reproduce the above copyright
     14 #    notice, this list of conditions and the following disclaimer in the
     15 #    documentation and/or other materials provided with the distribution.
     16 # 3. The name of the author may not be used to endorse or promote products
     17 #    derived from this software without specific prior written permission.
     18 #
     19 # THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
     20 # IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
     21 # OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
     22 # IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
     23 # INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
     24 # NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
     25 # DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
     26 # THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
     27 # (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
     28 # THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
     29 
     30 . "${srcdir=.}/init.sh"
     31 
     32 run_prog_skip_if_failed \
     33 	kill -0 $$
     34 
     35 check_prog sleep
     36 
     37 set -e
     38 
     39 rm -f "$LOG"
     40 ./set_ptracer_any sleep $((2*$TIMEOUT_DURATION)) > "$LOG" &
     41 
     42 while ! [ -s "$LOG" ]; do
     43 	kill -0 $! 2> /dev/null ||
     44 		fail_ 'set_ptracer_any sleep failed'
     45 	$SLEEP_A_BIT
     46 done
     47 
     48 tracee_pid=$!
     49 
     50 cleanup()
     51 {
     52 	set +e
     53 	kill $tracee_pid
     54 	wait $tracee_pid 2> /dev/null
     55 	return 0
     56 }
     57 
     58 rm -f "$LOG"
     59 $STRACE -p $tracee_pid 2> "$LOG" &
     60 
     61 while ! grep -F "Process $tracee_pid attached" "$LOG" > /dev/null; do
     62 	kill -0 $! 2> /dev/null || {
     63 		cleanup
     64 		dump_log_and_fail_with "$STRACE -p failed to attach"
     65 	}
     66 	$SLEEP_A_BIT
     67 done
     68 
     69 kill -INT $!
     70 wait $!
     71 
     72 grep -F "Process $tracee_pid detached" "$LOG" > /dev/null || {
     73 	cleanup
     74 	dump_log_and_fail_with "$STRACE -p failed to detach"
     75 }
     76 
     77 if [ -f /proc/self/status ]; then
     78 	$SLEEP_A_BIT
     79 	test -d /proc/$tracee_pid || {
     80 		cleanup
     81 		dump_log_and_fail_with 'tracee died after detach'
     82 	}
     83 	grep_pid_status "$tracee_pid" '^State:.*S (sleeping)' > /dev/null || {
     84 		grep_pid_status "$tracee_pid" '^State:'
     85 		cleanup
     86 		dump_log_and_fail_with 'tracee is not sleeping after detach'
     87 	}
     88 fi
     89 
     90 cleanup
     91 exit 0
     92